const request = require('request-promise')

module.exports = ((option) => {
  let {baseUrl} = option

  if(!baseUrl) {
    throw new Error('baseUrl required in restrict middleware')
  }
  else {
    return async (req, res, next) => {
      let {access_token} = req.query
      if(access_token){
        const result = await request({
          uri: `${baseUrl}/auth/verify`,
          qs: {
            access_token: access_token
          },
          method: "GET",
          json: true
        })
        if (result.errcode) {
          res.status(400).send(result.errmsg)
        } else {
          next()
        }
      }
      else {
        return res.status(400).send({error: 'access_token required'})
      }
    }
  }
})
